
/*
     File: ViewController.m
 Abstract: Simple collection view controller subclass to lay out views on a line.
 
  Version: 1.0
 
 Disclaimer: IMPORTANT:  This Apple software is supplied to you by Apple
 Inc. ("Apple") in consideration of your agreement to the following
 terms, and your use, installation, modification or redistribution of
 this Apple software constitutes acceptance of these terms.  If you do
 not agree with these terms, please do not use, install, modify or
 redistribute this Apple software.
 
 In consideration of your agreement to abide by the following terms, and
 subject to these terms, Apple grants you a personal, non-exclusive
 license, under Apple's copyrights in this original Apple software (the
 "Apple Software"), to use, reproduce, modify and redistribute the Apple
 Software, with or without modifications, in source and/or binary forms;
 provided that if you redistribute the Apple Software in its entirety and
 without modifications, you must retain this notice and the following
 text and disclaimers in all such redistributions of the Apple Software.
 Neither the name, trademarks, service marks or logos of Apple Inc. may
 be used to endorse or promote products derived from the Apple Software
 without specific prior written permission from Apple.  Except as
 expressly stated in this notice, no other rights or licenses, express or
 implied, are granted by Apple herein, including but not limited to any
 patent rights that may be infringed by your derivative works or by other
 works in which the Apple Software may be incorporated.
 
 The Apple Software is provided by Apple on an "AS IS" basis.  APPLE
 MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS
 FOR A PARTICULAR PURPOSE, REGARDING THE APPLE SOFTWARE OR ITS USE AND
 OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
 
 IN NO EVENT SHALL APPLE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION,
 MODIFICATION AND/OR DISTRIBUTION OF THE APPLE SOFTWARE, HOWEVER CAUSED
 AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE),
 STRICT LIABILITY OR OTHERWISE, EVEN IF APPLE HAS BEEN ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
 
 Copyright (C) 2012 Apple Inc. All Rights Reserved.
 
 
 WWDC 2012 License
 
 NOTE: This Apple Software was supplied by Apple as part of a WWDC 2012
 Session. Please refer to the applicable WWDC 2012 Session for further
 information.
 
 IMPORTANT: This Apple software is supplied to you by Apple
 Inc. ("Apple") in consideration of your agreement to the following
 terms, and your use, installation, modification or redistribution of
 this Apple software constitutes acceptance of these terms.  If you do
 not agree with these terms, please do not use, install, modify or
 redistribute this Apple software.
 
 In consideration of your agreement to abide by the following terms, and
 subject to these terms, Apple grants you a non-exclusive license, under
 Apple's copyrights in this original Apple software (the "Apple
 Software"), to use, reproduce, modify and redistribute the Apple
 Software, with or without modifications, in source and/or binary forms;
 provided that if you redistribute the Apple Software in its entirety and
 without modifications, you must retain this notice and the following
 text and disclaimers in all such redistributions of the Apple Software.
 Neither the name, trademarks, service marks or logos of Apple Inc. may
 be used to endorse or promote products derived from the Apple Software
 without specific prior written permission from Apple.  Except as
 expressly stated in this notice, no other rights or licenses, express or
 implied, are granted by Apple herein, including but not limited to any
 patent rights that may be infringed by your derivative works or by other
 works in which the Apple Software may be incorporated.
 
 The Apple Software is provided by Apple on an "AS IS" basis.  APPLE
 MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS
 FOR A PARTICULAR PURPOSE, REGARDING THE APPLE SOFTWARE OR ITS USE AND
 OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
 
 IN NO EVENT SHALL APPLE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION,
 MODIFICATION AND/OR DISTRIBUTION OF THE APPLE SOFTWARE, HOWEVER CAUSED
 AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE),
 STRICT LIABILITY OR OTHERWISE, EVEN IF APPLE HAS BEEN ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
 
 */

#import "ViewController.h"
#import "Cell.h"

@implementation ViewController

#define numberOfItems 40
-(void)viewDidLoad
{
	[super viewDidLoad];
    [self.collectionView registerClass:[Cell class] forCellWithReuseIdentifier:@"MY_CELL"];
    
    // add our gesture recognizer to the grid view
    UILongPressGestureRecognizer * gr = [[UILongPressGestureRecognizer alloc] initWithTarget: self action: @selector(moveActionGestureRecognizerStateChanged:)];
    gr.minimumPressDuration = 0.5;
    gr.delegate = self;
    [self.collectionView addGestureRecognizer: gr];
    
    self.collectionView.pagingEnabled = YES;
    _numberOfPages = numberOfItems / 20;
    
    
    pageControl = [[UIPageControl alloc] initWithFrame:CGRectMake(0, 440, 320, 20)];
    pageControl.numberOfPages = _numberOfPages;
    pageControl.currentPage = 0;
    [self.view addSubview:pageControl];
    
    self.collectionView.delegate = self;

}

- (NSInteger)collectionView:(PSUICollectionView *)view numberOfItemsInSection:(NSInteger)section;
{
    return numberOfItems;
}

- (NSInteger)numberOfSectionsInCollectionView:(PSTCollectionView *)collectionView
{
    return 1;
}

- (PSUICollectionViewCell *)collectionView:(PSUICollectionView *)cv cellForItemAtIndexPath:(NSIndexPath *)indexPath;
{
//    static NSString * EmptyIdentifier = @"EmptyIdentifier";
//    if ( indexPath == _emptyCellIndex )
//    {
//       // NSLog( @"Loading empty cell at index %u", index );
//        PSTCollectionViewCell * hiddenCell = [cv dequeueReusableCellWithReuseIdentifier: EmptyIdentifier forIndexPath:indexPath];
//        if ( hiddenCell == nil )
//        {
//            // must be the SAME SIZE AS THE OTHERS
//            // Yes, this is probably a bug. Sigh. Look at -[AQGridView fixCellsFromAnimation] to fix
//            hiddenCell = [[PSTCollectionViewCell alloc] initWithFrame: CGRectMake(0.0, 0.0, 60.0, 60.0)];
//        }
//        
//        hiddenCell.hidden = YES;
//        return hiddenCell;
//    }
    
    
    Cell *cell = [cv dequeueReusableCellWithReuseIdentifier:@"MY_CELL" forIndexPath:indexPath];
    cell.label.text = [NSString stringWithFormat:@"%d",indexPath.item];
    return cell;
}

-(BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation {
    return UIInterfaceOrientationIsLandscape(toInterfaceOrientation);
}


- (BOOL) gestureRecognizerShouldBegin: (UIGestureRecognizer *) gestureRecognizer
{
    CGPoint location = [gestureRecognizer locationInView: self.collectionView];
    if ( [self.collectionView indexPathForItemAtPoint: location].row < numberOfItems )
        return ( YES );
    
    // touch is outside the bounds of any icon cells, so don't start the gesture
    return ( NO );
}

- (void) moveActionGestureRecognizerStateChanged: (UIGestureRecognizer *) recognizer
{
    switch ( recognizer.state )
    {
        default:
        case UIGestureRecognizerStateFailed:
            // do nothing
            break;
            
        case UIGestureRecognizerStatePossible:
        case UIGestureRecognizerStateCancelled:
        {
            //[_gridView beginUpdates];
            
            if ( _emptyCellIndex != _dragOriginIndex )
            {
                //[self.collectionView moveItemAtIndex: _emptyCellIndex toIndex: _dragOriginIndex withAnimation: AQGridViewItemAnimationFade];
                [self.collectionView moveItemAtIndexPath:_emptyCellIndex toIndexPath:_dragOriginIndex];
            }
            
            _emptyCellIndex = _dragOriginIndex;
            
            // move the cell back to its origin
            [UIView beginAnimations: @"SnapBack" context: NULL];
            [UIView setAnimationCurve: UIViewAnimationCurveEaseOut];
            [UIView setAnimationDuration: 0.5];
            [UIView setAnimationDelegate: self];
            [UIView setAnimationDidStopSelector: @selector(finishedSnap:finished:context:)];
            
            CGRect f = _draggingCell.frame;
            f.origin = _dragOriginCellOrigin;
            _draggingCell.frame = f;
            
            [UIView commitAnimations];
            
            //[_gridView endUpdates];
            
            break;
        }
            
        case UIGestureRecognizerStateEnded:
        {
            CGPoint p = [recognizer locationInView: self.collectionView];
            NSIndexPath *index = [self.collectionView indexPathForItemAtPoint: p];
            Cell *destinationCell = (Cell *)[self.collectionView cellForItemAtIndexPath:index];
//			if ( index == NSNotFound )
//			{
//				// index is the last available location
//				index = [_icons count] - 1;
//			}
            
            // update the data store
//            id obj = [_icons objectAtIndex: _dragOriginIndex];
//            [_icons removeObjectAtIndex: _dragOriginIndex];
//            [_icons insertObject: obj atIndex: index];
//            
//            if ( index != _emptyCellIndex )
//            {
//                [_gridView beginUpdates];
//                [_gridView moveItemAtIndex: _emptyCellIndex toIndex: index withAnimation: AQGridViewItemAnimationFade];
//                _emptyCellIndex = index;
//                [_gridView endUpdates];
//            }
            
            // move the real cell into place
            [UIView beginAnimations: @"SnapToPlace" context: NULL];
            [UIView setAnimationCurve: UIViewAnimationCurveEaseOut];
            [UIView setAnimationDuration: 0.5];
            [UIView setAnimationDelegate: self];
            [UIView setAnimationDidStopSelector: @selector(finishedSnap:finished:context:)];
            
            CGRect r = [self.collectionView convertRect:destinationCell.frame toView:self.view];
            CGRect f = _draggingCell.frame;
            f.origin.x = r.origin.x + floorf((r.size.width - f.size.width) * 0.5);
            f.origin.y = r.origin.y + floorf((r.size.height - f.size.height) * 0.5) - self.collectionView.contentOffset.y;
            NSLog( @"Gesture ended-- moving to %@", NSStringFromCGRect(f) );
            _draggingCell.frame = f;
            
            _draggingCell.transform = CGAffineTransformIdentity;
            _draggingCell.alpha = 1.0;
            
            [UIView commitAnimations];
            break;
        }
            
        case UIGestureRecognizerStateBegan:
        {
            NSIndexPath *index = [self.collectionView indexPathForItemAtPoint: [recognizer locationInView: self.collectionView]];
            _emptyCellIndex = index;    // we'll put an empty cell here now
            
            // find the cell at the current point and copy it into our main view, applying some transforms
            Cell * sourceCell = (Cell *)[self.collectionView cellForItemAtIndexPath: index];
            CGRect frame = [self.view convertRect: sourceCell.frame fromView: self.collectionView];
            _draggingCell = [[Cell alloc] initWithFrame:frame];
            _draggingCell.label.text = [NSString stringWithFormat:@"%d",index.item];
            //_draggingCell.icon = [_icons objectAtIndex: index];
            [self.view addSubview: _draggingCell];
            
            // grab some info about the origin of this cell
            _dragOriginCellOrigin = frame.origin;
            _dragOriginIndex = index;
            
            [UIView beginAnimations: @"" context: NULL];
            [UIView setAnimationDuration: 0.2];
            [UIView setAnimationCurve: UIViewAnimationCurveEaseOut];
            
            // transformation-- larger, slightly transparent
            _draggingCell.transform = CGAffineTransformMakeScale( 1.2, 1.2 );
            _draggingCell.alpha = 0.7;
            
            // also make it center on the touch point
            _draggingCell.center = [recognizer locationInView: self.view];
            
            [UIView commitAnimations];
            
            // reload the grid underneath to get the empty cell in place
           // [self.collectionView reloadItemsAtIndices: [NSIndexSet indexSetWithIndex: index]
                       //       withAnimation: AQGridViewItemAnimationNone];
            NSArray *array = [NSArray arrayWithObject:index];
            [self.collectionView reloadItemsAtIndexPaths:array];
            
            break;
        }
            
        case UIGestureRecognizerStateChanged:
        {
            // update draging cell location
            _draggingCell.center = [recognizer locationInView: self.view];
            
            // don't do anything with content if grid view is in the middle of an animation block
//            if ( _gridView.isAnimatingUpdates )
//                break;
            
            // update empty cell to follow, if necessary
//            NSUInteger index = [_gridView indexForItemAtPoint: [recognizer locationInView: _gridView]];
            
            if (_draggingCell.center.x > 270) {
                [self performSelector:@selector(nextPage) withObject:nil afterDelay:0.7];
               // [self nextPage];
            }else {
                [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(nextPage) object:nil];
            }
            
            if (_draggingCell.center.x < 50) {
                [self performSelector:@selector(prevPage) withObject:nil afterDelay:0.7];
                //[self prevPage];
            }else {
                [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(prevPage) object:nil];
            }
            
            NSIndexPath *index = [self.collectionView indexPathForItemAtPoint:[recognizer locationInView:self.collectionView]];
			
			// don't do anything if it's over an unused grid cell
			if ( index == nil )
			{
				// snap back to the last possible index
				index = [NSIndexPath indexPathForRow:39 inSection:0];
			}
			
            if ( index != _emptyCellIndex )
            {
                NSLog( @"Moving empty cell from %u to %u", _emptyCellIndex.row, index.row );
                
                // batch the movements
                //[_gridView beginUpdates];
                
                // move everything else out of the way
                if ( index < _emptyCellIndex )
                {
                    for ( NSUInteger i = index.row; i < _emptyCellIndex.row; i++ )
                    {
                        NSLog( @"Moving %u to %u", i, i+1 );
//                        [_gridView moveItemAtIndex: i toIndex: i+1 withAnimation: AQGridViewItemAnimationFade];
                        [self.collectionView moveItemAtIndexPath:[NSIndexPath indexPathForRow:i inSection:0] toIndexPath:[NSIndexPath indexPathForRow:i+1 inSection:0]];
                    }
                }
                else
                {
                    for ( NSUInteger i = index.row; i > _emptyCellIndex.row; i-- )
                    {
                        NSLog( @"Moving %u to %u", i, i-1 );
//                        [_gridView moveItemAtIndex: i toIndex: i-1 withAnimation: AQGridViewItemAnimationFade];
                        [self.collectionView moveItemAtIndexPath:[NSIndexPath indexPathForRow:i inSection:0] toIndexPath:[NSIndexPath indexPathForRow:i-1 inSection:0]];
                    }
                }
                
//                [_gridView moveItemAtIndex: _emptyCellIndex toIndex: index withAnimation: AQGridViewItemAnimationFade];
                [self.collectionView moveItemAtIndexPath:_emptyCellIndex toIndexPath:index];
                _emptyCellIndex = index;
                
                //[_gridView endUpdates];
            }
            
            break;
        }
    }
}

- (void) finishedSnap: (NSString *) animationID finished: (NSNumber *) finished context: (void *) context
{
//    NSIndexSet * indices = [[NSIndexSet alloc] initWithIndex: _emptyCellIndex];
//    _emptyCellIndex = NSNotFound;
//    
//    // load the moved cell into the grid view
//    [_gridView reloadItemsAtIndices: indices withAnimation: AQGridViewItemAnimationNone];
//    
    // dismiss our copy of the cell
    [_draggingCell removeFromSuperview];
    _draggingCell = nil;
    
}


- (void) nextPage
{
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(nextPage) object:nil];
    
    if (pageControl.currentPage < pageControl.numberOfPages - 1) {
        int page = pageControl.currentPage + 1;
        
        // update the scroll view to the appropriate page
        CGRect frame = self.collectionView.frame;
        frame.origin.x = frame.size.width * page;
        frame.origin.y = 0;
        [self.collectionView scrollRectToVisible:frame animated:YES];
    }
}

- (void) prevPage
{
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(prevPage) object:nil];
    if (pageControl.currentPage > 0) {
        int page = pageControl.currentPage - 1;

        CGRect frame = self.collectionView.frame;
        frame.origin.x = frame.size.width * page;
        frame.origin.y = 0;
        [self.collectionView scrollRectToVisible:frame animated:YES];
    }
}

- (void)scrollViewDidScroll:(UIScrollView *)sender
{

    CGFloat pageWidth = self.collectionView.frame.size.width;
    int page = floor((self.collectionView.contentOffset.x - pageWidth / 2) / pageWidth) + 1;
    pageControl.currentPage = page;
    
}


@end

